// RangeImage.h: RangeImage NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RANGEIMAGE_H__9BAB51CC_D243_455B_98FA_661B6FB44DCF__INCLUDED_)
#define AFX_RANGEIMAGE_H__9BAB51CC_D243_455B_98FA_661B6FB44DCF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "math.h"

class RangeImage  
{
public:
	int sizeX, sizeY;
	float **I;
	float (**normal)[3];
	float (**normal_f)[3];
	float **Ix, **Iy;
	float **Ixx, **Ixy, **Iyx, **Iyy;
	bool **isRidge, **isRavine, **isEdge;

public:
	void copyImage(RangeImage* image);
	void detectEdge(float T);
	void detectFeatureAngle(float T);
	void computeFaceNormal();
	double H(int i, int j);
	double K(int i, int j);
	void computeNablaNabla();
	void computeNablaFromNormal();
	void reflectNabla();
	void reflectImage();
	void computeNabla();
	void computeNormal();
	void setSize(int sizeX, int sizeY);
	RangeImage();
	virtual ~RangeImage();
};

#endif // !defined(AFX_RANGEIMAGE_H__9BAB51CC_D243_455B_98FA_661B6FB44DCF__INCLUDED_)
