// RangeImageViewerDoc.cpp : CRangeImageViewerDoc NX̓̒`s܂B
//

#include "stdafx.h"
#include "RangeImageViewer.h"

#include "RangeImageViewerDoc.h"
#include "RangeImageViewerView.h"

#include "RangeImage.h"
#include "FileManager.h"

#include "NoiseDialog.h"
#include "RidgeDialog.h"
#include "SmoothDialog.h"
#include "NormalDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define PI 3.14159265358979

/////////////////////////////////////////////////////////////////////////////
// CRangeImageViewerDoc

IMPLEMENT_DYNCREATE(CRangeImageViewerDoc, CDocument)

BEGIN_MESSAGE_MAP(CRangeImageViewerDoc, CDocument)
	//{{AFX_MSG_MAP(CRangeImageViewerDoc)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_IMAGE, OnImage)
	ON_COMMAND(ID_WIRE, OnWire)
	ON_COMMAND(ID_V_NORMAL, OnVNormal)
	ON_COMMAND(ID_SMOOTH, OnSmooth)
	ON_COMMAND(ID_RIDGE, OnRidge)
	ON_COMMAND(ID_NORMAL, OnNormal)
	ON_COMMAND(ID_NOISE, OnNoise)
	ON_COMMAND(ID_F_NORMAL, OnFNormal)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_UNDO, OnUndo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static char file_ex[] = "All files(*.*)|*.*|PGM files(*.PGM)|*.PGM|Float array files(*.DAT)|*.DAT|";

/////////////////////////////////////////////////////////////////////////////
// CRangeImageViewerDoc NX̍\z/

CRangeImageViewerDoc::CRangeImageViewerDoc()
{
	// TODO: ̈ʒuɂPxĂ΂\zp̃R[hǉĂB
	file_manager = new FileManager;
	smoother = new Smoother;
	image = NULL;
	last_image = NULL;

	smooth_dia = new SmoothDialog;
	noise_dia = new NoiseDialog;
	ridge_dia = new RidgeDialog;
	normal_dia = new NormalDialog;
}

CRangeImageViewerDoc::~CRangeImageViewerDoc()
{
	if(image != NULL)
		delete image;
	if(last_image != NULL)
		delete last_image;
	delete file_manager;
	delete smoother;
	delete smooth_dia;
	delete noise_dia;
	delete ridge_dia;
	delete normal_dia;
}

BOOL CRangeImageViewerDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CRangeImageViewerDoc VAC[[V

void CRangeImageViewerDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: ̈ʒuɕۑp̃R[hǉĂB
	}
	else
	{
		// TODO: ̈ʒuɓǂݍݗp̃R[hǉĂB
	}
}

/////////////////////////////////////////////////////////////////////////////
// CRangeImageViewerDoc NX̐ff

#ifdef _DEBUG
void CRangeImageViewerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CRangeImageViewerDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRangeImageViewerDoc R}h

void CRangeImageViewerDoc::OnFileOpen() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CFileDialog* dia = new CFileDialog(TRUE, NULL, NULL, 
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, file_ex, NULL);
	
	if(dia->DoModal() == IDOK){
		if(image != NULL)
			delete image;
		image = new RangeImage;
		smoother->setRangeImage(image);
		file_manager->setRangeImage(image);

		if(dia->GetFileExt() == "dat")
			file_manager->readFile(dia->GetPathName());
		else
			file_manager->readFileByYagou(dia->GetPathName());
                                                                                                                                                                                                                           
		image->reflectImage();
		image->computeNabla();
		image->computeNormal();
		image->computeFaceNormal();

		//smoother->averageNormal(50, 50);
		//smoother->averageFaceNormal(20, 30);

		mode = 0;
		changeView();
	}
	delete dia;
}

void CRangeImageViewerDoc::drawImage()
{
	if(image == NULL)
		return;
	POSITION pos = GetFirstViewPosition();
	CRangeImageViewerView* pView = (CRangeImageViewerView*)GetNextView(pos);
	switch(mode){
	case 0:
		pView->flatShading(image);
		break;
	case 1:
		pView->drawImageWithRidge(image);
		break;
	case 2:
		pView->drawShadedImage(image);
		break;
	case 3:
		pView->wireFrame(image);
		break;
	case 4:
		pView->drawImage(image);
		break;
	}
}

void CRangeImageViewerDoc::OnImage() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	mode = 4;
	changeView();
}

void CRangeImageViewerDoc::OnWire() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	mode = 3;	
	changeView();
}

void CRangeImageViewerDoc::OnVNormal() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	image->reflectImage();
	image->computeNabla();
	image->computeNormal();

	mode = 2;
	changeView();
}

void CRangeImageViewerDoc::OnSmooth() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(smooth_dia->DoModal() == IDOK){
		if(last_image != NULL)
			delete last_image;
		last_image = new RangeImage;
		last_image->copyImage(image);

		float c = smooth_dia->m_T;
		int iter = smooth_dia->m_iter;
		if(smooth_dia->m_method == "Gauss Smoothing"){
			smoother->gaussSmooth(iter, c);
			image->computeFaceNormal();
			OnFNormal();
		}
		else{
			image->computeFaceNormal();
			smoother->smoothI(iter, c);
			OnFNormal();
		}
	}
}

void CRangeImageViewerDoc::OnRidge() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(ridge_dia->DoModal() == IDOK){
		image->detectFeatureAngle((float)(-cos(PI*ridge_dia->m_T/180.0)));
		image->detectEdge(20);
		mode = 1;
		changeView();
	}
}

void CRangeImageViewerDoc::OnNormal() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(normal_dia->DoModal() == IDOK){
		float c = normal_dia->m_T;
		int iter = normal_dia->m_iteration;
		if(normal_dia->m_type == "Vertex normal"){
			image->reflectImage();
			image->computeNabla();
			image->computeNormal();

			smoother->averageNormal(iter,c);

			mode = 2;
			changeView();
		}
		else{
			image->computeFaceNormal();

			smoother->averageFaceNormal(iter, c);

			mode = 0;
			changeView();
		}
	}
}

void CRangeImageViewerDoc::OnNoise() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(noise_dia->DoModal() == IDOK){
		if(last_image != NULL)
			delete last_image;
		last_image = new RangeImage;
		last_image->copyImage(image);

		smoother->addNoise(noise_dia->m_size);
		OnFNormal();
	}
}

void CRangeImageViewerDoc::OnFNormal() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	image->computeFaceNormal();
	
	mode = 0;
	changeView();
}	

void CRangeImageViewerDoc::OnFileSaveAs() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CFileDialog* dia = new CFileDialog(FALSE, NULL, NULL, 
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, file_ex, NULL);
	if(dia->DoModal() == IDOK){
		CString name = dia->GetPathName();
		if(dia->GetFileExt() == "")
			name += ".dat";
		file_manager->writeDataFile(name);
	}
	delete dia;
}

void CRangeImageViewerDoc::OnFileSave() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	OnFileSaveAs();
}

void CRangeImageViewerDoc::OnUndo() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(last_image != NULL){
		delete image;
		image = last_image;
		last_image = NULL;
		OnFNormal();
		smoother->setRangeImage(image);
		file_manager->setRangeImage(image);
	}
}

void CRangeImageViewerDoc::changeView()
{
	POSITION pos = GetFirstViewPosition();
	CRangeImageViewerView* pView = (CRangeImageViewerView*)GetNextView(pos);
	pView->changeView();
}
